import { Context } from 'koa';
import user from './user';
import document from './document';
import bigFileUpload from './bigFileUpload';
import services from '../services';
import path from 'path';
import { readFileSync } from 'fs-extra';
import http from 'http';
import { user as User } from '@/models';
interface InterfaceParams {
  phone?: string
}
const home = async (ctx: Context): Promise<void> => {
  let a: string;
  await new Promise<void>((resolve) => {
    http.get('http://dev.ldy.client.qihoo.net/api/client/thirdapi/filedownload?id=1002&f_key=QEzedKKG9w3ljmtWYbwDaXz1d1hKgI6U_2019070310081642.zip&timestamp=1625652728&vulid=LDY-2021-00001795&token=515A016F0BEA3DBA5A7D9A0E5C776808', res => {
      res.on('data', d => {
        a += d;
      });
      res.on('end', () => {
        console.log(typeof a);
        resolve();
        // writeFileSync(path.resolve(__dirname, './test.zip'), a)
      });
    });
  });
  ctx.body = 'home';
};
// TODO: ws 待开发状态
const ws = async (ctx:Context): Promise<void> => {
  ctx.body = readFileSync(path.resolve(__dirname, '../../example/ws.html')).toString();
};
// TODO: 大文件切片上传，还需要完善
const upload = async (ctx:Context): Promise<void> => {
  ctx.body = readFileSync(
    path.resolve(__dirname, '../../example/bigFileUpload.html')
  ).toString();
};
// TODO: 读取验证码，待开发状态
const code = async (ctx: Context): Promise<void> => {
  const params: InterfaceParams = {};
  params.phone = ctx.query.phone as string;
  if (!params.phone) {
    ctx.status = 400;
    ctx.body = ctx.$response(null, 'phone参数缺失', false, 400000);
    return;
  }
  const body = await services.code(ctx, params);
  ctx.body = ctx.$response(body);
};

const register = async (ctx:Context): Promise<void> => {
  const { username, password } = ctx.request.body;
  console.log(username, password);
  User.create({
    name: username,
    password
  });
  ctx.body = 'ok';
};

export default {
  home,
  code,
  ws,
  upload,
  register,
  user,
  document,
  bigFileUpload
};
