import { Sequelize, ModelCtor, DataTypes } from 'sequelize';

export default (sequelize: Sequelize ): ModelCtor<any> => {
  const User = sequelize.define('user', {
    name: {
      type: DataTypes.STRING(90),
      allowNull: false
    },
    password: {
      type: DataTypes.STRING,
      allowNull: false
    },
    age: {
      type: DataTypes.INTEGER,
      defaultValue: 0
    },
    gender: {
      type: DataTypes.INTEGER,
      defaultValue: 0
    },
    job: DataTypes.STRING
  });
  return User;
};
