
module.exports = {
  apps: [
    {
      name: 'gateway',
      script: 'dist/app.js',
      exec_mode: 'cluster',
      watch: false,
      instances: 2,
      /**
       * @description pm2 cluster log4js日志丢失
       * @url https://www.cnblogs.com/javencs/p/10221172.html
       */
      instance_var: 'INSTANCE_ID',
      merge_logs: true,
      log_type: 'raw',
      cwd: './',
      args: '',
      env: {
        NODE_ENV: 'production',
        API_ENV: 'production'
      },
      env_dev: {
        NODE_ENV: 'development',
        API_ENV: 'development'
      }
    }
  ]
};
