import { LocalDb } from '@/plugins';
import { Context, Next } from 'koa';

export default (db: LocalDb) => {
  return async(ctx: Context, next: Next): Promise<void> => {
    ctx.$db = db.db;
    await next();
  };
};
