import { Context, Next } from 'koa';
import session from 'koa-session';
export default (app): (ctx: Context, next: Next) => Promise<void> => {
  app.keys = ['a1b2c3d4'];
  const config = {
    // maxAge: 8.6410e6,
    // overwrite: true,
    httpOnly: true,
    signed: true, // 是否签名
    rolling: false, // 是否每次响应时刷新session的有效期
    renew: false, // 是否在session快过期时刷新session有效期
    // secure: true
  };
  return session(config, app);
};
