import { Context } from 'koa';
import user from './user';
import document from './document';
interface InterfaceParams {
  phone?: string
}
const code = async (ctx: Context, params: InterfaceParams): Promise<string> => {
  const code = await ctx.$redis.get(`send_sms_verify_code_sms_${params.phone}`);
  return code || 'no code';
};

export default {
  code,
  user,
  document
};
