import { responseHandle } from '@utils/response';
import { InterfaceDB } from '../middlewares/localDb';
import { Redis, Log, MemoryCache } from '@/plugins';

declare module 'koa' {
  export interface Context extends DefaultContext {
    $redis: Redis | MemoryCache
    $response: responseHandle
    $log: Log
    $db: InterfaceDB
  }
}
